Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Timer1: TTimer;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  End;

  { TTest }

  TTest = Class(TThread)
  private
    fNeedWorkToDo: Boolean;
    fWorkIndex: integer;
    fWorkResult: String;
    fIsWorking: Boolean;
  protected
    Procedure Execute; override;
  public
    Function DoWork(Index: integer): String;
    Constructor Create;
  End;

Var
  Form1: TForm1;
  TestThread: TTest = Nil;
  WorkCounter: integer = 0;
  Fails: integer = 0;
  Suceeds: integer = 0;

Implementation

{$R *.lfm}

{ TTest }

Procedure TTest.Execute;
Var
  wi: integer;
Begin
  While Not Terminated Do Begin
    If fNeedWorkToDo Then Begin
      fIsWorking := true;
      wi := fWorkIndex;
      If random(100) < 10 Then Begin  // in 10 % aller Fälle können wir das Ergebnis nicht verarbeiten und brauchen ewig zum Auflösen..
        sleep(200);
      End;
      fWorkResult := inttostr(wi);
      fNeedWorkToDo := false;
      fIsWorking := false;
    End;
    sleep(1);
  End;
End;

Function TTest.DoWork(Index: integer): String;
Var
  i: int64;
Begin
  If fIsWorking Then Begin // So lange der Thread noch Arbeitet kann nichts bearbeitet werden also Raus
    result := '?';
    exit;
  End;
  fWorkIndex := index;
  fWorkResult := '?';
  fNeedWorkToDo := true; // Dem Thread Execute das Startsignal geben
  (*
   * Wir warten maximal 10ms, dann brechen wir ab.
   * ist Der Thread vorher Fertig setzt er sein fNeedWorkToDo auf False und wir können das Ergebnis
   * übernehmen
   *)
  i := GetTickCount64;
  While (GetTickCount64 - i <= 10) And fNeedWorkToDo Do Begin

  End;
  result := fWorkResult;
End;

Constructor TTest.Create;
Begin
  Inherited Create(true);
  FreeOnTerminate := true;
End;

{ TForm1 }

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  Button1.enabled := false;
  TestThread := TTest.Create;
  Button2.Enabled := true;
  button3.Enabled := true;

  TestThread.Start;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Var
  s: String;
Begin
  WorkCounter := WorkCounter + 1;
  s := TestThread.DoWork(WorkCounter);
  If s <> '?' Then Begin
    Suceeds := Suceeds + 1;
    If WorkCounter <> strtointdef(s, -1) Then Begin
      Raise Exception.Create(inttostr(WorkCounter) + ' <> ' + s);
    End;
  End
  Else Begin
    Fails := Fails + 1;
  End;
  caption := format('Fails : %d, Suceeds : %d', [Fails, Suceeds]);
End;

Procedure TForm1.Button3Click(Sender: TObject);
Begin
  timer1.interval := StrToIntDef(edit1.text, 100);
  Timer1.Enabled := true;
End;

Procedure TForm1.Button4Click(Sender: TObject);
Begin
  Timer1.Enabled := false;
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: boolean);
Begin
  If assigned(TestThread) Then TestThread.Terminate;
End;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  edit1.text := '10';
  Randomize;
  button2.Enabled := false;
  button3.Enabled := false;
End;

Procedure TForm1.Timer1Timer(Sender: TObject);
Begin
  Button2.Click;
End;

End.

